<%-- $Id:tree.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.Action"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.ExtensionsFile"
	import="net.sf.basedb.core.plugin.About"
	import="java.util.List"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
String getJoustExtensionPoint(String parentNode, ExtensionsControl ec, ExtensionPoint ep)
{
	String id = ep.getId();
	String name = ep.getName();
	if (name == null) name = id;
	String icon = ec.isEnabled(ep) ? "ExtensionPoint" : "ExtensionPointDisabled";
	ExtensionsFile f = ec.getFileByExtensionId(id);
	if ((f != null && f.hasError()) || ec.getLastExtensionPointError(id) != null) 
	{
		icon = "ExtensionPointError";
	}
	String joust = "ep = JoustMenu.addChildItem(" + parentNode +", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'extensionPointOnClick(\"" + id + "\")', " + 
			"'', '" + id + "')";
	return joust;
}
String getJoustExtension(String parentNode, ExtensionsControl ec, Extension ext)
{
	String id = ext.getId();
	About about = ext.getAbout();
	String name = about == null || about.getName() == null ? id : about.getName();
	String icon = ec.isEnabled(ext) ? "Extension" : "ExtensionDisabled";
	ExtensionsFile f = ec.getFileByExtensionId(id);
	if ((f != null && f.hasError()) || ec.getLastExtensionError(id) != null)
	{
		icon = "ExtensionError";
	}
	String joust = "ext = JoustMenu.addChildItem(" + parentNode + ", '" + icon + "', " + 
			"'" + HTML.javaScriptEncode(name) + "', 'extensionOnClick(\"" + id + "\")', " + 
			"'', '" + id + "')";
	return joust;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	%>
	<base:page title="" type="popup">
	<base:head scripts="newjoust.js" styles="newjoust.css">
	<script language="JavaScript">
	var isInitialised = false;
	function initialise() 
	{
		if (parent && parent.parent && parent.parent.adjustIFrameSize) parent.parent.adjustIFrameSize();
		var path = getRoot()+'images/joust/';
		IconStore.init();
		
		IconStore.addIcon('ExtensionPoint', path + 'extensionpoint.png', 16, 16);
		IconStore.addIcon('ExtensionPointSelected', path + 'extensionpointselected.png', 16, 16);
		IconStore.addIcon('ExtensionPointDisabled', path + 'extensionpointdisabled.png', 16, 16);
		IconStore.addIcon('ExtensionPointDisabledSelected', path + 'extensionpointdisabledselected.png', 16, 16);
		IconStore.addIcon('ExtensionPointError', path + 'extensionpointerror.png', 16, 16);
		IconStore.addIcon('ExtensionPointErrorSelected', path + 'extensionpointerrorselected.png', 16, 16);
		IconStore.addIcon('Extension', path + 'extension.png', 16, 16);
		IconStore.addIcon('ExtensionSelected', path + 'extensionselected.png', 16, 16);
		IconStore.addIcon('ExtensionDisabled', path + 'extensiondisabled.png', 16, 16);
		IconStore.addIcon('ExtensionDisabledSelected', path + 'extensiondisabledselected.png', 16, 16);
		IconStore.addIcon('ExtensionError', path + 'extensionerror.png', 16, 16);
		IconStore.addIcon('ExtensionErrorSelected', path + 'extensionerrorselected.png', 16, 16);
		IconStore.addIcon('XmlFile', path + 'item.gif', 18, 16);
		IconStore.addIcon('XmlFileError', path + 'itemerror.gif', 18, 16);
		IconStore.addIcon('XmlFileSelected', path + 'itemselected.gif', 18, 16);
		IconStore.addIcon('XmlFileErrorSelected', path + 'itemerrorselected.gif', 18, 16);
		IconStore.addIcon('JarFile', path + 'jarfile.png', 18, 16);
		IconStore.addIcon('JarFileError', path + 'jarfileerror.png', 18, 16);
		IconStore.addIcon('JarFileSelected', path + 'jarfileselected.png', 18, 16);
		IconStore.addIcon('JarFileErrorSelected', path + 'jarfileerrorselected.png', 18, 16);

		var byExtPoint = JoustMenu.addMenuItem(-1, 'Root', 'By extension point', 'rootOnClick()', '', '');
		var toolbars = JoustMenu.addChildItem(byExtPoint, 'Folder', 'Toolbars');
		var ep;
		var ext;
		<%
		ExtensionsControl ec = ExtensionsControl.get(dc);
		Iterator<ExtensionPoint<?>> extensionPoints = ec.getExtensionPoints();
		while (extensionPoints.hasNext())
		{
			ExtensionPoint ep = extensionPoints.next();
			String parent = ep.getId().startsWith("net.sf.basedb.clients.web.toolbar") ? 
					"toolbars" : "byExtPoint";
			%>
			<%=getJoustExtensionPoint(parent, ec, ep)%>
			<%
			Iterator<Extension<?>> extensions = ec.getExtensions(ep.getId());
			while (extensions.hasNext())
			{
				Extension ext = extensions.next();
				%>
				<%=getJoustExtension("ep", ec, ext)%>
				<%
			}
		}
		%>
		var byFile = JoustMenu.addMenuItem(-1, 'Root', 'By file', 'rootOnClick()');
		var file;
		<%
		Iterator<ExtensionsFile> files = ec.getFiles();
		while (files.hasNext())
		{
			ExtensionsFile ef = files.next();
			String efName = ef.getName();
			String icon = ef.isJar() ? "JarFile" : "XmlFile";
			if (ef.hasError()) icon += "Error";
			String id = efName;
			%>
			file = JoustMenu.addChildItem(byFile, '<%=icon%>', '<%=HTML.javaScriptEncode(efName)%>', 'fileOnClick("<%=efName%>")', '', '<%=id%>');
			<%
			Iterator<ExtensionPoint<?>> eps = ef.getExtensionPoints();
			while (eps.hasNext())
			{
				ExtensionPoint ep = eps.next();
				%>
				<%=getJoustExtensionPoint("file", ec, ep)%>
				<%
			}
			Iterator<Extension<?>> exts = ef.getExtensions();
			while (exts.hasNext())
			{
				Extension ext = exts.next();
				%>
				<%=getJoustExtension("file", ec, ext)%>
				<%
			}
		}
		%>
		JoustMenu.menuItems[byExtPoint].isOpen = true;
		JoustMenu.menuItems[byFile].isOpen = true;
		JoustMenu.draw('joust');
		isInitialised = true;
	}

	function openAll()
	{
		JoustMenu.openAll();
	}

	function closeAll()
	{
		JoustMenu.closeAll();
	}
	
	function setIcon(nodeId, iconName)
	{
		var icons = new Array();
		icons[nodeId] = iconName;
		setIconsByExternalId(icons);
	}
	
	function setChildIcons(parentNodeId, enable)
	{
		var node = JoustMenu.menuItems[parentNodeId];
		if (!node) return;
		var childNode = JoustMenu.menuItems[node.firstChildIndex];
		var icons = new Array();
		var numChildren = 0;
		while (childNode)
		{
			numChildren++;
			var iconName = childNode.iconName;
			var isDisabled = iconName.indexOf('Disabled') > 0; 
			if (enable && isDisabled)
			{
				iconName = iconName.replace('Disabled', '');
			}
			else if (!enable && !isDisabled)
			{
				iconName += 'Disabled';
			}
			icons[childNode.externalId] = iconName;
			childNode = JoustMenu.menuItems[childNode.nextItemIndex];
		}
		if (numChildren > 0) setIconsByExternalId(icons);
	}
	
	function setIconsByExternalId(icons)
	{
		for (var i = 0; i < JoustMenu.menuItems.length; i++)
		{
			var node = JoustMenu.menuItems[i];
			var iconName = icons[node.externalId];
			if (iconName)
			{
				node.iconName = iconName;
				JoustMenu.updateIconsAndText(node.index);
			}
		}
	}
	
	function selectFile(filename)
	{
		var fileNode = JoustMenu.menuItems[filename];
		if (fileNode)
		{
			JoustMenu.open(fileNode.index);
			JoustMenu.select(fileNode.index);
		}
	}
	
	function rootOnClick()
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>';
	}
	
	function extensionPointOnClick(extensionPointId)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&extensionPointId='+extensionPointId;
	}
	function extensionOnClick(extensionId)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&extensionId='+extensionId;
	}
	function fileOnClick(filename)
	{
		parent.frames['details'].location.href = 'details.jsp?ID=<%=ID%>&filename='+escape(filename);	
	}
	</script>
	</base:head>
		<base:body onload="initialise()">
		<div id="main" class="joust" style="width:100%;">
			<div id="joust" style="overflow: auto;">
			</div>
		</div>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
