<%-- $Id: edit_extravaluetype.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ExtraValueType"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.Coloring"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.EXTRAVALUETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ExtraValueType extraValueType = null;
	Coloring coloring = null;
	Formula.AverageMethod currentAverageMethod = null;

	if (itemId == 0)
	{
		title = "Create extra value type";
		cc.removeObject("item");
		currentAverageMethod = Formula.AverageMethod.fromValue(Values.getInt(cc.getPropertyValue("averageMethod"),
			Formula.AverageMethod.ARITHMETIC_MEAN.getValue()));
		coloring = new Coloring();
		coloring.setUsingColors(Values.getBoolean(cc.getPropertyValue("coloring.usingColors")));
		coloring.setLogarithmic(Values.getBoolean(cc.getPropertyValue("coloring.logarithmic")));
		coloring.setMinValue(Values.getFloat(cc.getPropertyValue("coloring.minValue"), null));
		coloring.setMidValue(Values.getFloat(cc.getPropertyValue("coloring.midValue"), null));
		coloring.setMaxValue(Values.getFloat(cc.getPropertyValue("coloring.maxValue"), null));
	}
	else
	{
		extraValueType = ExtraValueType.getById(dc, itemId);
		currentAverageMethod = extraValueType.getAverageMethod();
		coloring = extraValueType.getColoring();
		cc.setObject("item", extraValueType);
		title = "Edit extra value type -- " + HTML.encodeTags(extraValueType.getName());
	}
	if (extraValueType != null) extraValueType.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "ExtraValueType" tab
		function validateExtraValueType()
		{
			var frm = document.forms['extraValueType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			if (frm.use_colors.checked && !frm.use_colors.disabled)
			{
				var minValue = parseFloat(frm.min_value.value);
				var midValue = parseFloat(frm.mid_value.value);
				var maxValue = parseFloat(frm.max_value.value);
				if (isNaN(minValue))
				{
					alert('No min value has been specified');
					frm.min_value.focus();
					return false;
				}
				if (isNaN(midValue))
				{
					alert('No mid value has been specified');
					frm.mid_value.focus();
					return false;
				}
				if (isNaN(maxValue))
				{
					alert('No max value has been specified');
					frm.max_value.focus();
					return false;
				}
				if (minValue > midValue)
				{
					alert('The min value (' + minValue + ') can\'t be greater than the mid value (' + midValue + ')');
					return false;
				}
				if (midValue > maxValue)
				{
					alert('The mid (' + midValue + ') value can\'t be greater than the max value (' + maxValue + ')');
					return false;
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['extraValueType'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (extraValueType == null)
			{
				%>
				var frm = document.forms['extraValueType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			useColorsOnClick();
		}
		
		function useColorsOnClick()
		{
			var frm = document.forms['extraValueType'];
			var useColors = frm.use_colors.checked && !frm.use_colors.disabled;
			frm.min_value.disabled = !useColors;
			frm.mid_value.disabled = !useColors;
			frm.max_value.disabled = !useColors;
			frm.logarithmic.disabled = !useColors;
			if (useColors)
			{
				Main.addClass(frm.min_value, 'required');
				Main.addClass(frm.mid_value, 'required');
				Main.addClass(frm.max_value, 'required');
			}
			else
			{
				Main.removeClass(frm.min_value, 'required');
				Main.removeClass(frm.mid_value, 'required');
				Main.removeClass(frm.max_value, 'required');
			}
		}
		
		function valueTypeOnChange()
		{
			var frm = document.forms['extraValueType'];
			var valueType = frm.value_type[frm.value_type.selectedIndex].value;
			var use = valueType != 'STRING';
			frm.use_colors.disabled = !use;
			useColorsOnClick();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="extraValueType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom" remember="<%=extraValueType != null%>">
		<t:tab id="info" title="Extra value type" validate="validateExtraValueType()" 
			helpid="extravaluetype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(extraValueType == null ? Values.getString(cc.getPropertyValue("name"), "New extra value type") : extraValueType.getName())%>" 
					size="40" maxlength="<%=ExtraValueType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(extraValueType == null ? Values.getString(cc.getPropertyValue("externalId")) : extraValueType.getExternalId())%>" 
					size="40" maxlength="<%=ExtraValueType.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Value type</td>
				<td>
					<%
					if (extraValueType != null)
					{
						%>
						<%=extraValueType.getValueType()%>
						<%
					}
					else
					{
						int currentValueType = Values.getInt(cc.getPropertyValue("valueType"));
						%>
						<select name="value_type" class="required" onchange="valueTypeOnChange()">
						<option value="<%=Type.INT.name()%>" 
							<%=Type.INT.getValue() == currentValueType ? "selected" : "" %>><%=Type.INT%>
						<option value="<%=Type.FLOAT.name()%>"
							<%=Type.FLOAT.getValue() == currentValueType ? "selected" : "" %>><%=Type.FLOAT%>
						<option value="<%=Type.STRING.name()%>"
							<%=Type.STRING.getValue() == currentValueType ? "selected" : "" %>><%=Type.STRING%>
						</select>
						(can't be changed later)
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Avg. method</td>
				<td>
					<select name="averageMethod" class="required">
					<%
					for (Formula.AverageMethod method : Formula.AverageMethod.values())
					{
						String selected = method == currentAverageMethod ? "selected" : "";
						%>
						<option value="<%=method.name()%>" <%=selected%>><%=HTML.encodeTags(method.toString())%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<%
			if (extraValueType == null || extraValueType.getValueType().isNumerical())
			{
				%>
				<tr>
					<td class="prompt">Use colors</td>
					<td>
						<input type="checkbox" name="use_colors" value="1" 
							<%=coloring.isUsingColors() ? "checked" : "" %>
							onclick="useColorsOnClick()">
						
						<b>Min value</b>
						<input type="text" class="text" name="min_value"
							 value="<%=Values.formatNumber(coloring.getMinValue(), -1)%>"
							 size="6" maxlength="6"
							 onkeypress="return Numbers.numberOnly(event)"
							 >
						<b>Mid value</b>
						<input type="text" class="text" name="mid_value"
							 value="<%=Values.formatNumber(coloring.getMidValue(), -1)%>"
							 size="6" maxlength="6"
							 onkeypress="return Numbers.numberOnly(event)"
							 >
						<b>Max value</b>
						<input type="text" class="text" name="max_value"
							 value="<%=Values.formatNumber(coloring.getMaxValue(), -1)%>"
							 size="6" maxlength="6"
							 onkeypress="return Numbers.numberOnly(event)"
							 >
							 <br>
						<input type="checkbox" name="logarithmic" value="1" 
							<%=coloring.isLogarithmic() ? "checked" : "" %>>
						<b>Logarithmic</b>
					</td>
				</tr>
				<%
			}
			%>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(extraValueType == null ? cc.getPropertyValue("description") : extraValueType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'extraValueType', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
