<%-- $Id: edit_group.jsp 5077 2009-08-26 12:03:37Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.GROUP;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Group group = null;

	boolean isEveryone = false;
	boolean isDefault = false;
	boolean hiddenMembers = false;
	final QuotaType total = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
	Quota currentQuota = null;
	
	// Query to retrieve child groups
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve user members
	ItemQuery<User> userQuery = null;

	if (itemId == 0)
	{
		title = "Create group";
		cc.removeObject("item");
		if (cc.getPropertyFilter("quota.name") != null)
		{
			currentQuota = Base.getFirstMatching(dc, Quota.getQuery(), "name", cc.getPropertyFilter("quota.name"));
		}
		String[] selected = request.getParameterValues("user_id");
		if (selected != null)
		{
			userQuery = User.getQuery();
			userQuery.include(Include.ALL);
			userQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			userQuery.setParameter("selected", Arrays.asList(Values.getInt(selected)), Type.INT);
		}
		isDefault = Values.getBoolean(cc.getPropertyValue("default"), false);
		hiddenMembers = Values.getBoolean(cc.getPropertyValue("hiddenMembers"), false);
	}
	else
	{
		group = Group.getById(dc, itemId);
		cc.setObject("item", group);
		title = "Edit group -- " + HTML.encodeTags(group.getName());
		isEveryone = Group.EVERYONE.equals(group.getSystemId());
		isDefault = group.isDefault();
		hiddenMembers = group.hasHiddenMembers();

		try
		{
			currentQuota = group.getQuota();
		}
		catch (PermissionDeniedException ex)
		{}
		
		groupQuery = group.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		userQuery = group.getUsers();
		userQuery.include(Include.ALL);
		userQuery.order(Orders.asc(Hql.property("name")));
	}
	if (group != null && !group.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final boolean readQuota = sc.hasPermission(Permission.READ, Item.QUOTA);
	final boolean useQuota = sc.hasPermission(Permission.USE, Item.QUOTA);
	final boolean useUsers = sc.hasPermission(Permission.WRITE, Item.USER);
	final boolean writeGroups = sc.hasPermission(Permission.WRITE, Item.GROUP);
	final boolean writeMembers = useUsers && writeGroups;
	
	// Query to retrieve quota
	final ItemQuery<Quota> quotaQuery = Quota.getQuery();
	quotaQuery.include(Include.ALL);
	quotaQuery.order(Orders.asc(Hql.property("name")));
	quotaQuery.setCacheResult(true);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Group" tab
		function validateGroup()
		{
			var frm = document.forms['group'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Members" tab
		function validateMembers()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['group'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addUsers.value = Link.getActionIds(1, 'U').join(',');
				frm.removeUsers.value = Link.getActionIds(-1, 'U').join(',');
				frm.addGroups.value = Link.getActionIds(1, 'G').join(',');
				frm.removeGroups.value = Link.getActionIds(-1, 'G').join(',');
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (group == null)
			{
				%>
				var frm = document.forms['group'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initMembers();
		}
		function initMembers()
		{
			var members = document.forms['group'].members;
			Link.addNewSection(members, new Section('U', 'Users'));
			<%
			if (userQuery != null)
			{
				ItemResultList<User> users = userQuery.list(dc);
				String linkMethod = group == null ? "addItem" : "addNewItem";
				for (User user : users)
				{
					%>
					Link.<%=linkMethod%>(members, new Item('U', <%=user.getId()%>, '<%=HTML.javaScriptEncode(user.getName())%>'));
					<%
				}
			}
			%>
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			if (groupQuery != null)
			{
				ItemResultList<Group> children = groupQuery.list(dc);
				for (Group child : children)
				{
					%>
					Link.addNewItem(members, new Item('G', <%=child.getId()%>, '<%=HTML.javaScriptEncode(child.getName())%>'));
					<%
				}
			}
			%>
		}
		function addUsersOnClick()
		{
			var users = Link.getListIds(document.forms['group'].members, 'U');
			var url = '../users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addUserCallback';
			url += '&exclude='+users.join(',');
			Main.openPopup(url, 'AddUsers', 1000, 700);
		}
		function addUserCallback(userId, name)
		{
			var item = Link.getItem('U', userId);
			if (!item) item = new Item('U', userId, name);
			Link.addItem(document.forms['group'].members, item);
		}
		function addGroupsOnClick()
		{
			var groups = Link.getListIds(document.forms['group'].members, 'G');
			var url = '../groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback';
			url += '&exclude='+groups.join(',');
			Main.openPopup(url, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name);
			Link.addItem(document.forms['group'].members, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['group'].members);
		}
	
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="group" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom" remember="<%=group != null%>">
		<t:tab id="info" title="Group" validate="validateGroup()" helpid="group.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(group == null ? Values.getString(cc.getPropertyValue("name"), "New group") : group.getName())%>" 
					size="40" maxlength="<%=Group.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Default</td>
				<td>
					<input type="radio" name="is_default" value="0" <%=!isDefault ? "checked" : ""%>>no
					<input type="radio" name="is_default" value="1" <%=isDefault ? "checked" : ""%>>yes
				</td>
			</tr>	
			<tr>
				<td class="prompt">Hidden members</td>
				<td>
					<input type="radio" name="hidden_members" value="0" <%=!hiddenMembers ? "checked" : ""%>>no
					<input type="radio" name="hidden_members" value="1" <%=hiddenMembers ? "checked" : ""%>>yes
				</td>
			</tr>	
			<tr valign="top">
				<td class="prompt">Quota</td>
				<td>
					<select name="quota_id" <%=isEveryone || !useQuota ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readQuota)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<Quota> quotas = quotaQuery.list(dc);
						for (Quota quota : quotas)
						{
							boolean current = quota.equals(currentQuota);
							if (!current && quota.isRemoved()) continue;
							int id = quota.getId();
							long totalBytes = quota.getQuotaValue(total, Location.PRIMARY);
							String fTotal = totalBytes == Quota.UNLIMITED ? "unlimited" : Values.formatBytes(totalBytes);
							%>
							<option 
								value="<%=current && group != null ? -id : id%>" 
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(quota.getName())%> (<%=fTotal%> total)
							<%
						}
					}
					%>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(group == null ? cc.getPropertyValue("description") : group.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'group', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="members" title="Members" tooltip="Add/remove members of this group" 
			validate="validateMembers()" helpid="group.edit.membership">
		<table >
		<tr valign="top">
		<td>
			<b>Members</b><br>
			<select name="members" size="14" multiple <%=isEveryone || !writeMembers ? "disabled readonly class=\"disabled\"" : ""%> style="width: 15em;">
			</select>
			<input type="hidden" name="removeUsers" value="">
			<input type="hidden" name="addUsers" value="">
			<input type="hidden" name="removeGroups" value="">
			<input type="hidden" name="addGroups" value="">
		</td>
		<td>
			<br>
			<table width="150">
			<tr><td><base:button 
				onclick="addUsersOnClick()" 
				title="Add&nbsp;users&hellip;" 
				tooltip="Add users to this group"
				disabled="<%=isEveryone || !writeMembers %>" 
				/></td></tr>
			<tr><td><base:button 
				onclick="addGroupsOnClick()" 
				title="Add&nbsp;groups&hellip;"  
				tooltip="Add child groups to this group"
				disabled="<%=isEveryone || !writeMembers %>" 
			/></td></tr>
			<tr><td><base:button 
				onclick="removeOnClick()" 
				title="Remove" 
				tooltip="Remove the selected items from this group"
				disabled="<%=isEveryone || !writeMembers%>" 
			/></td></tr>
			</table>
		</td>
		</tr>
		</table>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
