<%-- $Id: ajax.jsp 5136 2009-10-15 06:33:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.InvalidDataException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="java.io.OutputStreamWriter"
	import="java.io.Writer"
	import="java.io.Reader"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
try
{
	if ("GetCharset".equals(cmd))
	{
		dc = sc.newDbControl();
		File f = File.getById(dc, itemId);
		String charset = f.getCharacterSet();
		out.println(charset == null ? "" : charset);
		dc.close();
	}
	else if ("StoreFile".equals(cmd))
	{
		try
		{
			int size = Values.getInt(request.getParameter("size"), -1);
			dc = sc.newDbControl();
			File f = File.getById(dc, itemId);
			Reader in = request.getReader();
			String charset = f.getCharacterSet();
			if (charset == null)
			{
				charset = Config.getCharset();
				f.setCharacterSet(charset);
			}
			Writer toFile = new OutputStreamWriter(
					f.getUploadStream(false, f.isCompressed()), charset);
			int copied = (int)FileUtil.copy(in, toFile);
			if (size >= 0 && copied != size)
			{
				throw new InvalidDataException("Incomplete file; expected " + size + 
					" bytes; got " + copied + ".");
			}
			toFile.flush();
			toFile.close();
			dc.commit();
			out.println("File saved successfully");
		}
		catch (Exception ex)
		{
			out.println("Save failed: " + ex.getMessage());
			ex.printStackTrace();
		}
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
%>